PUBLIC oForm
oForm=createobject("TestForm")
oForm.show

RETURN


DEFINE CLASS TestForm as FORM
autocenter=.t.
height=300
width=500
backcolor=RGB(192,192,192)
caption="3D Test"
left=10
top=2
scalemode=3

ADD OBJECT txtNote as ShadowTextBox
txtNote.value="Shadowed Text boxes"
txtNote.left=10
txtnote.top=10

ADD OBJECT BOX3D1 as BOX3D
Box3d1.Top=50
Box3d1.Left=50
Box3d1.width=350
*Box3d1.fillcolor=RGB(255,255,0)
Box3d1.borderwidth=5

ADD OBJECT BOX3D2 as BOX3D
Box3d2.Top=65
Box3d2.Left=65
Box3d2.width=320
Box3d2.height=THISFORM.Box3d1.height-30
Box3d2.fillcolor=RGB(255,255,0)
Box3d2.borderwidth=3
Box3d2.lRaised=.t.
Box3d2.lShowOutline=.F.

ADD OBJECT edtNote as ShadowEditBox
edtNote.value="Shadowed Editboxes"
edtNote.left=80
edtNote.top=120
edtNote.height=100
edtNote.width=250

ADD OBJECT ShadowLabel1 as ShadowLabel
ShadowLabel1.top=70
ShadowLabel1.left=80
ShadowLabel1.ForeColor = RGB(128,0,0)
ShadowLabel1.nOffset=2
ShadowLabel1.caption="Text Shadows"

ADD OBJECT ShadowLabel2 as ShadowLabel
ShadowLabel2.top=3
ShadowLabel2.left=225
ShadowLabel2.ForeColor = RGB(255,0,0)
ShadowLabel2.nOffset=2
ShadowLabel2.caption="ShadowLabel"
ShadowLabel2.cShadowColor="0,0,0"
ENDDEFINE


*************************************************
DEFINE CLASS Box3d AS Shape
*************************************************

*** Standard Properties
BorderStyle = 3
BorderWidth = 3
FillColor = RGB(192,192,192)
FillStyle = 0
Height = 200
Width = 200
Name = "box3d"

*** Determines whether raised boxes
*** show an outline box around object
lShowOutline = .T.

*** Box displays raised or lowered
lRaised = .F.

***************************************************
PROCEDURE Init
**************
LOCAL llRaised,lnColor1,lnColor2,lcName,x

llRaised=THIS.lRaised

*** Shadow Colors
lnGrey=RGB(128,128,128)
lnWhite=RGB(255,255,255)

*** Left Line - Use a Square object to
***             draw 'line'
lcName=THIS.Name+"_1"
THIS.parent.addobject(lcName,"Shape")
WITH THIS.parent.&lcName
  .top=THIS.top
  .left=THIS.left
  .width=THIS.borderwidth+1
  .height=THIS.height
  .borderwidth=0
  .fillcolor=IIF(llRaised,lnWhite,lnGrey)
  .fillstyle=0
  .visible=.t.
ENDWITH

*** Right Line - use square object
lcName=THIS.Name+"_2"
THIS.parent.addobject(lcName,"Shape")
WITH THIS.parent.&lcName
  .top=THIS.top
  .left=THIS.left+THIS.width-THIS.borderwidth
  .width=THIS.borderwidth+1
  .height=THIS.height
  .borderwidth=0
  .fillcolor=IIF(llRaised,lnGrey,lnWhite)
  .fillstyle=0
  .visible=.t.
ENDWITH

*** Top Line - Draw individual lines for each
***            width point for bevel effect
FOR x=1 TO THIS.borderwidth
   lcName=THIS.Name+"_3"+alltrim(STR(x))
   THIS.parent.addobject(lcName,"Line")
   WITH THIS.parent.&lcName
	  .top=THIS.top+x-1
	  .left=THIS.left
	  .width=THIS.width-x
	  .height=0
	  .borderwidth=1
	  .bordercolor=IIF(llRaised,lnWhite,lnGrey)
	  .visible=.t.
   ENDWITH
ENDFOR
   	  	  	  	  	  	  	
*** Bottom Line
FOR x=1 TO THIS.borderwidth
   lcName=THIS.Name+"_4"+alltrim(STR(x))
   THIS.parent.addobject(lcName,"Line")
   WITH THIS.parent.&lcName
	  .top=THIS.top+THIS.Height-x-1
	  .left=THIS.left+x-1
	  .width=THIS.width-x-1
	  .height=0
	  .borderwidth=1
	  .bordercolor=IIF(llRaised,lnGrey,lnWhite)
	  .visible=.t.
   ENDWITH
ENDFOR

*** Now hide the original box object outline
*** Note: Fill color still applies!
IF llRaised .AND. This.lShowOutline
	WITH THIS
	  .BorderWidth=2
	  .left=THIS.left-1
	  .top=THIS.top-1
	  .width=THIS.width+2
	  .height=THIS.height+1
	ENDWITH
ELSE
   THIS.borderwidth=0
ENDIF

ENDPROC
* Init

ENDDEFINE
* 3dBox


*************************************************
DEFINE CLASS Shadowlabel AS Label
*************************************************

*** Standard Properties
FontSize = 28
Alignment = 2                  && Center Text
BackStyle = 0                  && Transparent!
Caption = "ShadowLabel"
Height = 37
Width = 252
Name = "shadowlabel"

noffset = 2		&& Shadow Offset

*** Color for shadow cast. Use 3 RGB value string: 
*** "128,128,128" - no color picker
cShadowColor = "128,128,128"

*** Flag that is True when the object is created then set False once updated
PROTECTED lisinit
lisInit=.T.


*************************************************
PROCEDURE Init
**************
LOCAL lcName

lnOffset=THIS.nOffset

*** Create Shadow Object
lcName=THIS.name+"_1"
THIS.parent.addobject(lcName,"Label")
WITH THIS.parent.&lcName
   *** Copy Properties
   .Caption=THIS.caption
   .width=THIS.width
   .height=THIS.height
   .backstyle=0              && Transparent
   .forecolor=EVALUATE("RGB("+THIS.cShadowColor+")")
   .fontsize=THIS.Fontsize
   .fontname=THIS.fontname
   .fontbold=THIS.fontbold
   .alignment=THIS.alignment
	
   .top=THIS.Top+lnOffset
   .left=THIS.Left+lnOffset
   .visible=.t.
ENDWITH

*** NOTE: Refresh contains ZOrder(0) to bring
***       Label to front of shadow

ENDPROC
* Init

*************************************************
PROCEDURE Refresh
*****************
LPARAMETER lcCaption
LOCAL lcName

lcCaption=IIF(type("lcCaption")="C",;
              lcCaption,THIS.Caption)

THIS.caption=lcCaption

*** Update the shadow object
lcName=THIS.name+"_1"
IF TYPE("THIS.parent."+lcName)="O"
   THIS.parent.&lcName..caption=lcCaption
ENDIF

*** Bring original Text back to front
*** from behind shadow only when form loads
IF THIS.lIsInit
   THIS.zorder(0)
   THIS.lIsInit=.F.

   *** Zorder() workaround
   *** - make sure all items get refreshed
   THIS.parent.refresh
ENDIF

ENDPROC
*Refresh

ENDDEFINE
* ShadowLabel

*************************************************
DEFINE CLASS Shadowtextbox AS Textbox
*************************************************
Height = 23
SpecialEffect = 1      && Plain
BorderWidth=1		   && Need Border
Width = 175
Name = "shadowtextbox"

*** Custom Properties
noffset = 7
cShadowColor = "128,128,128"

*************************************************
PROCEDURE Init
**************
LOCAL lcName,lnOffset

lnOffset=THIS.nOffset

*** Bottom Shadow Box
lcName=THIS.name+"_1"
THIS.parent.addobject(lcName,"SHAPE")
WITH THIS.parent.&lcName
   *** Copy Properties
   .width=THIS.width
   .height=lnOffset
   .top=THIS.top+THIS.height
   .left=THIS.left+lnOffset
   .borderstyle=0
   .borderwidth=0
   .fillstyle=0
   .fillcolor=EVALUATE("RGB("+THIS.cShadowColor+")")
   .visible=.t.
ENDWITH

*** Right Shadow Box
lcName=THIS.name+"_2"
THIS.parent.addobject(lcName,"SHAPE")
WITH THIS.parent.&lcName
   *** Copy Properties
   .width=lnOffset
   .height=THIS.height
   .left=This.left+THIS.width
   .top=THIS.top+lnOffset
   .borderstyle=0
   .borderwidth=0
   .fillstyle=0
   .fillcolor=EVALUATE("RGB("+THIS.cShadowColor+")")
   .visible=.t.
ENDWITH

ENDPROC
* Init
	
ENDDEFINE
* ShadowText

*************************************************
DEFINE CLASS Shadoweditbox AS Editbox
*************************************************

*** Standard Properties
FontBold = .F.
Height = 76
SpecialEffect = 1
Width = 297
Name = "shadoweditbox"

*** Custom Properties
noffset = 7            
cShadowColor = "128,128,128"

*************************************************
PROCEDURE Init
**************
LOCAL lcName,lnOffset

lnOffset=THIS.nOffset

*** Bottom Shadow Box
lcName=THIS.name+"_1"
THIS.parent.addobject(lcName,"SHAPE")
WITH THIS.parent.&lcName
   *** Copy Properties
   .width=THIS.width
   .height=lnOffset
   .top=THIS.top+THIS.Height
   .left=THIS.left+lnOffset
   .borderstyle=0
   .borderwidth=0
   .fillstyle=0
   .fillcolor=EVALUATE("RGB("+THIS.cShadowColor+")")
   .visible=.t.
ENDWITH

*** Right Shadow Box
lcName=THIS.name+"_2"
THIS.parent.addobject(lcName,"SHAPE")
WITH THIS.parent.&lcName
   *** Copy Properties
   .width=lnOffset
   .height=THIS.height
   .left=This.left+THIS.width
   .top=THIS.top+lnOffset
   .borderstyle=0
   .borderwidth=0
   .fillstyle=0
   .fillcolor=EVALUATE("RGB("+THIS.cShadowColor+")")
   .visible=.t.
ENDWITH

ENDPROC
* Init

ENDDEFINE
* ShadowEditBox


